align 2

define(numMonsters, 0)
define(monsterFreq, 0)

define(MONSTER, 
  `define(`numMonsters', eval(numMonsters+1))
  divert(SEQUENCE_STRINGS)
  define(`MONSTER_NAME', `MONSTER'`'numMonsters`'NAME)
  export MONSTER_NAME
  string `$2'
  
  divert(SEQUENCE_TABLES)
  align 2
  export MONSTER_`'$1
  link  MONSTER_NAME     #name
  uchar $3               #drawchar
  uchar `$4'             #level
  uchar `$5'             #dv
  uchar `$6'             #pv
  sint  `$7'             #hps
  uchar `$8'             #spd
  divert(SEQUENCE_TEMP)
  define(`numAttacks', 0)
  $9
  divert(SEQUENCE_TABLES)
  uchar numAttacks       #numattacks
  uint  `$10'             #xp
  uint  `$11'            #flags
  undivert(SEQUENCE_TEMP)
  align 2
 ')

define(BASE_ATTACK,
 `define(`numAttacks', eval(numAttacks+1))
  align 2
  range($2,$1)  # Damage
  schar $3      # To-hit
  uchar $4      # Type
  uchar $5      # Trigger
  align 2
 ')

define(TRIGGER_NORMAL,  0)
define(TRIGGER_RANGE,   1)
define(TRIGGER_DEFENSE, 2)
define(TRIGGER_DEATH,   3)

define(ZAP,       1)
define(BITE,      2)
define(CLAW,      3)
define(KICK,      4)
define(PARAL,     5)
define(PARALONLY, 6)
define(POIS,      7)
define(POIS_BITE, 8)
define(RUST,      9)
define(SEALGOLD,  10)
define(STEALITEM, 11)
define(POIS_STING,12)

define(ATT,         `BASE_ATTACK($1, $2, 0, 0, 0)')
define(ATTACK,      `BASE_ATTACK($1, $2, $3, $4, TRIGGER_NORMAL)')
define(DEFATTACK,   `BASE_ATTACK($1, $2, $3, $4, TRIGGER_DEFENSE)')
define(DEATHATTACK, `BASE_ATTACK($1, $2, $3, $4, TRIGGER_DEATH)')

define(MOVERANDOMLY, 1)
define(REGENERATE,   2)  # 2 hps/turn
define(INVISIBLE,    4)
define(EVASIVE,      8)
define(TAME,         16)

BEGIN_JUMPTAB(MONSTERTABLE, jt_avglevel)
#         Monster              Freq   Level range
  JTENTRY(MONSTER_BAT,         2,     range(3,1))
  JTENTRY(MONSTER_EMU,         3,     range(3,1))
  JTENTRY(MONSTER_KOBOLD,      3,     range(4,1))
  JTENTRY(MONSTER_GOBLIN,      3,     range(5,2))
  JTENTRY(MONSTER_RATTLESNAKE, 3,     range(5,3))
  JTENTRY(MONSTER_ORC,         3,     range(7,4))
  JTENTRY(MONSTER_SKELETON,    3,     range(8,4))
  JTENTRY(MONSTER_ZOMBIE,      3,     range(9,5))
  JTENTRY(MONSTER_NYMPH,       1,     range(12,6))
  JTENTRY(MONSTER_AQUATOR,     1,     range(14,6))
  JTENTRY(MONSTER_HOBGOBLIN,   3,     range(13,6))
  JTENTRY(MONSTER_ICEMONSTER,  3,     range(15,7))
  JTENTRY(MONSTER_KILLERBEE,   3,     range(17,7))
  JTENTRY(MONSTER_TROLL,       2,     range(25,8))
  JTENTRY(MONSTER_CENTAUR,     2,     range(28,9))
  JTENTRY(MONSTER_YETI,        2,     range(30,10))
  JTENTRY(MONSTER_GRIFFIN,     2,     range(35,12))
  JTENTRY(MONSTER_JABBERWOCK,  2,     range(45,14))
  JTENTRY(MONSTER_QUAGGA,      2,     range(255,16))
END_JUMPTAB()

# Monster descriptors
# These are ripped straight out of Rogue. I'll consider monster abilities to be fully implemented when all of these
# can work as specified. Real monsters will come later.
#
#########################################################################################################################################################
#                     Name                  Char  Level  DV  PV  HPs  Spd  Attacks                                                   XP   Flags         #
# FINISHED ##############################################################################################################################################
MONSTER( BAT,         "Bat",                <B>,  1,     3,  0,  4,   15,  `ATTACK(1,3,0,CLAW)',                                     2,   MOVERANDOMLY  )
MONSTER( EMU,         "Emu",                <E>,  2,     6,  0,  8,   10,  `ATT(1,4)',                                               8,   0             )
MONSTER( KOBOLD,      "Kobold",             <K>,  2,     7,  0,  10,  10,  `ATT(2,5)',                                               15,  0             )
MONSTER( GOBLIN,      "Goblin",             <g>,  3,     6,  0,  15,  10,  `ATT(3,8)',                                               25,  0             )
MONSTER( ORC,         "Orc",                <O>,  3,     6,  1,  20,  10,  `ATT(3,9)',                                               50,  0             )
MONSTER( SKELETON,    "Skeleton",           <S>,  4,     2,  5,  12,  10,  `ATT(4,10)',                                              35,  0             )
MONSTER( RATTLESNAKE, "Rattlesnake",        <R>,  4,     4,  2,  16,  8,   `ATTACK(2,6,0,POIS_BITE)',                                30,  0             )
MONSTER( AQUATOR,     "Aquator",            <A>,  5,     15, 2,  25,  10,  `ATTACK(0,0,0,RUST)',                                     50,  0             )
MONSTER( NYMPH,       "Nymph",              <N>,  5,     12, 0,  17,  13,  `ATTACK(1,4,0,STEALITEM)',                                30,  0             )
MONSTER( ICEMONSTER,  "Ice Monster",        <I>,  6,     13, 1,  15,  2,   `ATTACK(3,5,0,PARALONLY) DEFATTACK(13,26,0,PARALONLY)',   30,  0             )
MONSTER( ZOMBIE,      "Zombie",             <Z>,  7,     10, 2,  25,  6,   `ATTACK(5,12,0,CLAW) ATTACK(5,12,0,CLAW)',                60,  0             )
MONSTER( KILLERBEE,   "Killer bee",         <b>,  7,     14, 0,  13,  12,  `ATTACK(5,9,0,POIS_STING)',                               70,  0             )
MONSTER( HOBGOBLIN,   "Hobgoblin",          <H>,  8,     10, 1,  15,  10,  `ATT(8,12)',                                              60,  0             )
MONSTER( TROLL,       "Troll",              <T>,  9,     19, 3,  40,  10,  `ATT(10,15)',                                             100, REGENERATE    )
MONSTER( CENTAUR,     "Centaur",            <C>,  10,    17, 2,  35,  15,  `ATTACK(8,16,0,KICK)',                                    120, 0             )
MONSTER( YETI,        "Yeti",               <Y>,  11,    15, 2,  45,  10,  `ATT(9,15)',                                              140, 0             )
MONSTER( GRIFFIN,     "Griffin",            <G>,  13,    30, 0,  33,  20,  `ATT(8,14)',                                              150, 0             )
MONSTER( JABBERWOCK,  "Jabberwock",         <J>,  15,    20, 3,  50,  10,  `ATT(10,25)',                                             200, 0             )
# HALF_FINISHED ###########################################################################################################################################
# ...By which I mean, finishing them doesn't require any features that aren't there yet, but they aren't finished.
MONSTER( QUAGGA,      "Quagga",             <Q>,  1,     0,  0,  0,   10,  `ATT(0,0)',                                               1,   0             )
# UNFINISHED ##############################################################################################################################################
# Making these monsters work requires significant code work that hasn't been done yet.
#
# Need to implement ranged attacks for breath weapons
#ONSTER( DRAGON,      "Dragon",             <D>,  1,     0,  0,  0,   0,   `ATT(0,0)',                                               1,   0             )
# Need to go research and figure out exactly what these do
#ONSTER( VENUSFLYTRAP,"Venus Flytrap",      <F>,  1,     0,  0,  0,   0,   `ATT(0,0)',                                               1,   0             )
# Need to implement gold entirely, so they can steal it
#ONSTER( LEPRECHAUN,  "Leprechaun",         <L>,  1,     0,  0,  0,   0,   `ATT(0,0)',                                               1,   0             )
# Need to implement confusion gaze (also useful for umber hulks)
#ONSTER( MEDUSA,      "Medusa",             <M>,  1,     0,  0,  0,   0,   `ATT(0,0)',                                               1,   0             )
# Need to implement invisibility and ways to detect it
#ONSTER( PHANTOM,     "Phantom",            <P>,  1,     0,  0,  0,   0,   `ATT(0,0)',                                               1,   INVISIBLE     )
# Need to implement a new monster AI
#ONSTER( UNICORN,     "Unicorn",            <U>,  1,     0,  0,  0,   0,   `ATT(0,0)',                                               1,   EVASIVE       )
# Need to implement life-draining
#ONSTER( VAMPIRE,     "Vampire",            <V>,  1,     0,  0,  0,   0,   `ATT(0,0)',                                               1,   0             )
# Need to implement experience-draining
#ONSTER( WRAITH,      "Wraith",             <W>,  1,     0,  0,  0,   0,   `ATT(0,0)',                                               1,   0             )
# Need to implement item copying. Xerox, Xeroc, get it? Ha, ha?
#ONSTER( XEROC,       "Xeroc",              <X>,  1,     0,  0,  0,   0,   `ATT(0,0)',                                               1,   0             )

# More unfinished monsters ripped out of NetHack.
# Some may be ready to finish, most aren't.
#ONSTER( COCKATRICE,  "Cockatrice",         <c>,  1,     0,  0,  0,   0,   `ATT(0,0)',                                               1,   0             )
#ONSTER( DOG,         "Dog",                <d>,  1,     0,  0,  0,   0,   `ATT(0,0)',                                               1,   TAME          )
#ONSTER( FLOATINGEYE, "Floating eye",       <e>,  1,     0,  0,  0,   0,   `ATT(0,0)',                                               1,   0             )
#ONSTER( GASSPORE,    "Gas spore",          <e>,  1,     0,  0,  0,   0,   `ATT(0,0)',                                               1,   0             )
#ONSTER( GELATCUBE,   "Gelatinous cube",    <g>,  1,     0,  0,  0,   0,   `ATT(0,0)',                                               1,   0             )
#ONSTER( OCHREJELLY,  "Ochre jelly",        <j>,  1,     0,  0,  0,   0,   `ATT(0,0)',                                               1,   0             )
#ONSTER( PIERCER,     "Piercer",            <p>,  1,     0,  0,  0,   0,   `ATT(0,0)',                                               1,   0             )
#ONSTER( XAN,         "Xan",                <x>,  1,     0,  0,  0,   0,   `ATT(0,0)',                                               1,   0             )
#ONSTER( YELLOWLIGHT, "Yellow light",       <y>,  1,     0,  0,  0,   0,   `ATT(0,0)',                                               1,   0             )
#afhiklmnoqrstuvwz

