#include "crogue.h"

#define NUM_DEBUGOPTS 8

//{{{
const char* debugmenuopts[NUM_DEBUGOPTS] = {
	"Gain level",
	"Gain attributes",
	"Heal",
	"Invulnerability",
	"Drain satiation",
	"Show free mem",
	"Reveal map",
	"Dump shuffle tab"
};
//}}}
//{{{
void debugmenu_pick(int N, char *buf)
{
	strcpy(buf, debugmenuopts[N]);
}
//}}}

//{{{
//
// Debug menu: opens a list of debug (cheat) commands and handles the
// selection
//
void debug(void)
{
	int i;
	int choice = UI_Menu_Pick( COORD(20,20), COORD(60,50), NUM_DEBUGOPTS, &debugmenu_pick, 0);
	
	// Indeces correspond to debugmenuopts strings
	switch( choice )
	{
		case 0:	// Gain level
			w->plr.xp = 10000;
			break;
		case 1:	// Gain attributes
			for(i=0; i<5; i++)
				w->plr.intrinsic[i] += 10;
			
			update_player();
			break;
		case 2: // Heal
			w->plr.hps = w->plr.hps_max;
			break;
		case 3: // Pseudo-invulnerability
			w->plr.hps = w->plr.hps_max = 1000;
			break;
		case 4:	// Remove satiation
			w->plr.satiation -= 200;
			break;
		case 5:	// Show free memory
#ifdef IS_CALCULATOR
			message("Free memory: %li", HeapAvail());
#else
			message("Free memory: Rediculously huge.");
#endif
			break;
		case 6:
			magic_map();
			break;
		case 7:
			for(i=0; i<w->desc.shuffletabsize; i++)
				message("%i, ", w->shuffletranslation[i]);
			break;
	}
	
	UI_TF_FullRedraw(&w->tilefield);
}
//}}}
