// constdata.h
// Structures that appears in the constant data file, and structures used by them.

//{{{
typedef struct world_descriptor
{
	filelink tileoffset;
	filelink mapoffset;
	filelink itemoffset;
	filelink generate_item;
	filelink startinginventory;
	filelink spelllist;
	filelink playerclasses;
	filelink stsizes;
	filelink stdata;
	filelink titlescreen_light_plane;
	filelink titlescreen_dark_plane;
	
	uint itementries;
	uint numspells;
	uint numplayerclasses;
	uint numshuffletabs;
	uint shuffletabsize;
} world_descriptor;
//}}}

//{{{
typedef struct tiledesc
{
	uchar drawchar;
	uchar transparent;
	uchar passable;
	uchar is_connection;
} tiledesc;
//}}}
//{{{
typedef struct spelldesc
{
	filelink name;
	uint effect;
	uint pp_cost;
	uint difficulty;
	uint padding;
} spelldesc;
//}}}
//{{{
typedef struct classdesc
{
	filelink name;
	
	range strength, dexterity, toughness, mana, willpower;
	uint spellcasting;
} classdesc;
//}}}
