//{{{
typedef struct monstattack
{
	range damage;
	schar tohit;
	uchar type;
	uchar trigger;
	uchar pad;
} monstattack;

#define MATTACK_NORM      0
#define MATTACK_ZAP       1
#define MATTACK_BITE      2
#define MATTACK_CLAW      3
#define MATTACK_KICK      4
#define MATTACK_PARAL     5
#define MATTACK_PARALONLY 6
#define MATTACK_POIS      7
#define MATTACK_POIS_BITE 8
#define MATTACK_RUST      9
#define MATTACK_STEALGOLD 10
#define MATTACK_STEALITEM 11
#define MATTACK_POISSTING 12

#define MTRIGGER_NORMAL   0
#define MTRIGGER_RANGED   1
#define MTRIGGER_DEFENSE  2
#define MTRIGGER_DEATH    3
//}}}
//{{{
typedef struct monstdesc
{
	filelink name;
	uchar drawchar;
	uchar level;
	uchar dv;
	uchar pv;
	sint hps_max;
	uchar speed;
	
	uchar numattacks;
//	filelink attacks;
	
	uint xp;
	uint flags;
	
	monstattack attacks[1];
} monstdesc;
//}}}

typedef struct monster	// 12 bytes
{
	filelink type;
	sshort hps;	
	uchar energy;
	uchar flags;
	sshort x, y;
} monster;

#define MONSTFLAG_MOVERANDOMLY 1
#define MONSTFLAG_REGENERATE   2
#define MONSTFLAG_INVISIBLE    4

void addrandommonst(void);
void addmonster(ushort x, ushort y);
int monstbytile(ushort x, ushort y);
const char* monstname(int n);
void monst_remove(int monstid);
int monst_takedamage(int monstid, int damage, int is_melee);
void monst_heal(int monstid, int amt);
int monst_hit_plr(int attacknum, int monster);
void monst_attack_plr(int attacknum, int monster);
void monstmove(sint i);
monstdesc *find_monster_description(int m);

