#define NUM_STATS 14

#define STAT_STRENGTH       0
#define STAT_DEXTERITY      1
#define STAT_TOUGHNESS      2
#define STAT_MANA           3
#define STAT_WILLPOWER      4
#define STAT_DV             5
#define STAT_PV             6
#define STAT_TOHIT          7
#define STAT_DAMAGE_MIN     8
#define STAT_DAMAGE_MAX     9
#define STAT_LIGHTRADIUS    10
#define STAT_SPEED          11
#define STAT_REGEN          12
#define STAT_PPREGEN        13

typedef struct player
{
	sshort x, y;
	
	sint class;
	
	sshort hps, hps_max;
	sshort pps, pps_max;
	
	uint   partialhps;
	uint   partialpps;
	
	uchar  level;

	sint intrinsic[NUM_STATS];
	sint extrinsic[NUM_STATS];
	
	ulong  xp;          // Number of XP points NEEDED to gain a level
	sint   xpdiffactor; // Modifier applied additively to all XP received
	                    // so that monsters below the player's level are
	                    // worth less.
	
	uint conftime;      // Number of turns until conf/hallu wears off, or
	uint hallutime;     // 0 if no conf/hallu.
	uint paraltime;
	int satiation;      // Number of turns until starvation
	
	int numitems;
	item inventory[PLRINVSIZE];
	
	int *spellknowledge;
	
	slong score;
} player;


int plr_attack_monster_roll(int monstid, int modifier);

void init_player(void);
void update_player(void);
void plr_move(void);
void plr_takedamage(int amt);
void plr_heal(int amt);
void plr_mod_stat(int which, int amt);
void manip_door(int open);
void place_player_randomly(void);
void awardXP(int amt);
void enter_map(void);


