#include "crogue.h"

#define MESSAGEFIELD_X 0
#define MESSAGEFIELD_Y 0
#define MESSAGEFIELD_ROWS 2
#define MESSAGEFIELD_WIDTH SCREEN_COLUMNS

static draw_string_info MF_state;

//{{{
void message(const char *format, ...)
{
	char buf[512];
	va_list varargs;
	
	va_start(varargs, format);
	vsprintf(buf, format, varargs);
	va_end(varargs);
	
	if(!w->messagevis)
		UI_MF_clear();

	UI_MF_sendmsg(buf);
	w->messagevis = 1;
}
//}}}

//{{{
void UI_MF_clear(void)
{
	// Reset pos
	MF_state.curX = 0;
	MF_state.curRow = 0;
	
#ifdef IS_CALCULATOR
	clear_string(0, 0, 160, 2);
#else
	clear_line(0);
	clear_line(1);
#endif
}
//}}}
//{{{
void UI_MF_sendmsg(const char *msg)
{
	if(MF_state.curX)
		draw_string(" ", &MF_state, MESSAGEFIELD_X, MESSAGEFIELD_Y, MESSAGEFIELD_WIDTH, MESSAGEFIELD_ROWS, 1);
	
	draw_string(msg, &MF_state, MESSAGEFIELD_X, MESSAGEFIELD_Y, MESSAGEFIELD_WIDTH, MESSAGEFIELD_ROWS, 1);
}
//}}}
//{{{
void UI_MF_wait(void)
{
	UI_MF_sendmsg("-More-");
	READCHAR;
	UI_MF_clear();
}
//}}}

